import turtle
import math

step_size = 5 #default

def hanoi(n,lr,cur,inter,dest):
    if n==0: #base case
        return

    mult = 1 if lr else -1 #left to right or right to left

    turtle.right(mult*120)

    hanoi(n-1,not lr, cur, inter, dest) #solve sub problem

    print "Move disk %d to %s" % (n,inter) #print move

    turtle.left(mult*90) #visually move to next state
    turtle.forward(step_size)
    turtle.left(mult*30)

    hanoi(n-1,lr,dest,inter,cur) #solve sub problem

    print "Move disk %d to %s" % (n,dest) #print move

    turtle.right(mult*150) #move to next state
    turtle.forward(step_size)
    turtle.left(mult*270)

    hanoi(n-1,not lr, cur, inter, dest) #solve sub problem

    turtle.right(mult*120) #Fix orientation

n = int(raw_input("Enter n: ")) #number of disks
turtle.clear()
turtle.seth(90) #Point north
turtle.speed(int(raw_input("Enter speed [1,100]: "))) #Drawing speed
step_size = int(raw_input("Enter step size: ")) #Size of steps
xpos = (pow(2,n) - 1)*step_size #Calculations to center drawing
ypos = (math.sqrt(3) * xpos)// 2
turtle.pu()
turtle.setpos(-xpos//2, -ypos//2)
turtle.pd()
#turtle.tracer(2,0) -- Uncomment to drastically increase animation speed
hanoi(n,True, 'A','B','C')
turtle.exitonclick() #Freeze screen after finish
